<template>
    <div class="content__leftAnalitika">
        <div class="pc vld-parent">
            <p class="text-title">{{ $t('currencies.title') }}</p>
            <loading :active="show_loading"
                     :can-cancel="false"
                     :is-full-page="true">
                <hollow-dots-spinner
                    :animation-duration="1000"
                    :dot-size="30"
                    :dots-num="3"
                    color="#3068e8"
                />
            </loading>
            <transition-group name="fadeUp" tag="div" class="box-pc--flex">
                <currency
                    v-for="(currency, i) in currencies"
                    :is_all_updating="is_updating"
                    :delay="i * 0.2"
                    :key="currency.id"
                    :currency="currency"
                    :style="delayStyle(i)"
                    @deleted="deleteItem"
                    @updated-rate="updateCurrency"
                    @updating="currencyUpdating"
                />
                <div class="box__pc--add" :style="delayStyle(addIndex)" @click="add" key="add">
                    <p class="text-blueAdd">{{ $t('currencies.add_button_first') }}<span>{{ $t('currencies.add_button_second') }}</span></p>
                    <img src="/img/blueblock.png" alt="" class="blue-img">
                </div>
                <div class="box__pc--add" :style="delayStyle(updateIndex)" @click="updateRates" key="update_rates">
                    <p class="text-blueAdd">{{ $t('currencies.update_button_first') }}<span>{{ $t('currencies.update_button_second') }}</span></p>
                    <img src="/img/blueblock.png" alt="" class="blue-img">
                </div>
            </transition-group>
        </div>
    </div>
</template>

<script>
    import {mapGetters} from 'vuex';
    import Loading from 'vue-loading-overlay';
    import {HollowDotsSpinner} from 'epic-spinners'
    import route from "../mixins/route";
    import Currency from "../components/currencies/Currency";
    import currencies from "../currencies";

    export default {
		name: "Currencies",
        mixins: [route],
        data(){
		    return {
		        count: 5,
                is_updating: false,
                show_loading: false,
            }
        },
        watch: {
		    is_updating(val){
		        this.show_loading = val;
            }
        },
        computed: {
		    ...mapGetters([
		        'axios'
            ]),
            currencies(){
                return currencies.currencies;
            },
            addIndex(){
		        return Array.isArray(this.currencies) ? this.currencies.length : 0
            },
            updateIndex(){
		        return Array.isArray(this.currencies) ? this.currencies.length + 1 : 0
            },
        },
        methods: {
            updateRates(){
		        this.is_updating = true;
                this.axios
                    .get('currencies/update_rates')
                    .then(resp => resp.data)
                    .then(data => {
                        this.$swal('Успешно', 'Курсы обновлены', 'success');
                        this.currencies = data.currencies;
                    })
                    .finally(() => {
                        this.is_updating = false;
                    })
                ;
            },
            currencyUpdating(val){
		        this.show_loading = val;
            },
            updateCurrency(){
		        currencies.loadData()
            },
            delayStyle(index){
		        const delay = index * 0.2;
                return delay ? {
                    'animation-delay': Number.parseFloat(delay).toFixed(2)+'s',
                } : { };
            },
            deleteItem(){
                currencies.loadData()
            },
            add(){
                this.$router.push(this.route('currencies_create'));
            }
        },
        components: {
		    Currency, Loading, HollowDotsSpinner
        }
	}
</script>

<style scoped lang="scss">
    .box__pc--add{
        cursor: pointer;
    }
</style>
